#include "CMUCam2.h"
#include "cmucamlib.h"

JNIEXPORT void JNICALL Java_CMUCam2_runCommand (JNIEnv *env, jobject obj, jstring cmd) {
	jclass cls = (*env)->GetObjectClass(env, obj);
	jobject T_obj, S_obj;
	jclass T_cls, S_cls;
	jfieldID fid;
	jstring jstr;

	struct cmucam2_retval cret;

	const char *str = (*env)->GetStringUTFChars(env, cmd, 0);
	//printf("%s\n", str);

	cret = cmucam2_run_command(str);

	// cret.T.mx = 1;
	// cret.T.my = 2;
	// cret.ret_type = S;

	(*env)->ReleaseStringUTFChars(env, cmd, str);

	// set the return type
	fid = (*env)->GetFieldID(env, cls, "returnType", "I");
	(*env)->SetIntField(env, obj, fid, cret.ret_type);

	// grab the T obj
	fid = (*env)->GetFieldID(env, cls, "T", "LCMUCam2$Tpacket;");
	T_obj = (*env)->GetObjectField(env, obj, fid);
	T_cls = (*env)->GetObjectClass(env, T_obj);

	// set all the T fields
	fid = (*env)->GetFieldID(env, T_cls, "mx", "I");
	(*env)->SetIntField(env, T_obj, fid, cret.T.mx);

	fid = (*env)->GetFieldID(env, T_cls, "my", "I");
	(*env)->SetIntField(env, T_obj, fid, cret.T.my);

	fid = (*env)->GetFieldID(env, T_cls, "x1", "I");
	(*env)->SetIntField(env, T_obj, fid, cret.T.x1);

	fid = (*env)->GetFieldID(env, T_cls, "x2", "I");
	(*env)->SetIntField(env, T_obj, fid, cret.T.x2);

	fid = (*env)->GetFieldID(env, T_cls, "y1", "I");
	(*env)->SetIntField(env, T_obj, fid, cret.T.y1);

	fid = (*env)->GetFieldID(env, T_cls, "y2", "I");
	(*env)->SetIntField(env, T_obj, fid, cret.T.y2);

	fid = (*env)->GetFieldID(env, T_cls, "pixels", "I");
	(*env)->SetIntField(env, T_obj, fid, cret.T.pixels);

	fid = (*env)->GetFieldID(env, T_cls, "confidence", "I");
	(*env)->SetIntField(env, T_obj, fid, cret.T.confidence);

	// grab the S obj
	fid = (*env)->GetFieldID(env, cls, "S", "LCMUCam2$Spacket;");
	S_obj = (*env)->GetObjectField(env, obj, fid);
	S_cls = (*env)->GetObjectClass(env, S_obj);

	// set the S fields
	fid = (*env)->GetFieldID(env, S_cls, "Rmean", "I");
	(*env)->SetIntField(env, S_obj, fid, cret.S.Rmean);

	fid = (*env)->GetFieldID(env, S_cls, "Gmean", "I");
	(*env)->SetIntField(env, S_obj, fid, cret.S.Gmean);

	fid = (*env)->GetFieldID(env, S_cls, "Bmean", "I");
	(*env)->SetIntField(env, S_obj, fid, cret.S.Bmean);

	fid = (*env)->GetFieldID(env, S_cls, "Rdeviation", "I");
	(*env)->SetIntField(env, S_obj, fid, cret.S.Rdeviation);

	fid = (*env)->GetFieldID(env, S_cls, "Gdeviation", "I");
	(*env)->SetIntField(env, S_obj, fid, cret.S.Gdeviation);

	fid = (*env)->GetFieldID(env, S_cls, "Bdeviation", "I");
	(*env)->SetIntField(env, S_obj, fid, cret.S.Bdeviation);

	// set the string
	fid = (*env)->GetFieldID(env, cls, "STR", "Ljava/lang/String;");
	(*env)->SetObjectField(env, obj, fid, (*env)->NewStringUTF(env, cret.STR));
}

JNIEXPORT void JNICALL Java_CMUCam2_Init (JNIEnv *env, jobject obj, jstring port) {
	const char *str = (*env)->GetStringUTFChars(env, port, 0);
	cmucam2_init(str, 0);
	(*env)->ReleaseStringUTFChars(env, port, str);
}

JNIEXPORT void JNICALL Java_CMUCam2_unInit (JNIEnv *env, jobject obj) {
	cmucam2_uninit();
}
